#ifndef CompilerTokensH
#define CompilerTokensH
//---------------------------------------------------------------------------
enum TTokenID
{
  NOTHING,       //  0
	NOT = '!',     // 33
	SSTRING,       // 34
	FIELD,         // 35
	MOD = '%',     // jump to 37
	AND,           // 38
	CCONST,        // 39
	LPAREN,        // 40
	RPAREN,        // 41
	MULT,          // 42
	ADD,           // 43
	COMMA,         // 44
	SUB,           // 45
	PERIOD,        // 46
	DIV,           // 47
	COLON = ':',   // jump to 58
	SCOLON,        // 59
	LT,            // 60
	ASSIGN,        // 61
	GT,            // 62
	ELSE = 'A',    // jump to 65
	WHILE,         // 66 (B)
	FOR,           // 67 (C)
	RETURN,        // 68 (D)
	EQ,            // 69 (E)
	IF,            // 70 (F)
	GE,            // 71 (G)
	EEi_CHAR,      // 72 (H)
	EEi_INT = 73,  // 73 (I)
	EELONG = 73,   // reset back to 73 (I)
	NE,            // 74 (J)
	LE,            // 75 (K)
	DO,            // 76 (L)
	LIBFUNC,       // 77 (M)
	VAR,           // 78 (N)
	LBRACKET = 91, // jump to 91 ([)
	RBRACKET = 93, // jump to 93 (])
	UDFUNCCALL = 109,  // jump to 109 (m)
	UDFUNCDECL = 110,  // jump to 110 (n)
	LBRACE = 123,  // jump to 123 ({)
	OR,            // 124 (|)
	RBRACE,        // 125 (})
	FINISHED,      // 126 (~)
	END            // 127
};

enum TTokenType
{
	APPFIELD,
	BLOCK,
	CHARCONST,
	DELIMITER,
	EEERROR,
	FUNCTION,
	IDENTIFIER,
	KEYWORD,
	NUMBER,
	NUMCONST,
	OPERATOR,
	STRING,
	TEMP,
	VARIABLE,
	CONSTRUCT
};
#endif
