//---------------------------------------------------------------------------

#ifndef EngineErrorsPumpH
#define EngineErrorsPumpH
//---------------------------------------------------------------------------

#include <string>
#include <vector>

typedef struct {
	std::string EngineClassName;
	std::string FunctionName;
	std::string ErrorMessage;
} TEngineError;


class TEngineErrorsPump
{
private:
	std::vector<TEngineError*> FPump;
public:
	TEngineErrorsPump();
	~TEngineErrorsPump();

	int ClearPump();

	int AddError(TEngineError* error);
	// overloaded
	int AddError(std::string class_name, std::string function_name, std::string error_message);
	int GetErrorsCount(int* how_many_errors);
	int GetErrorByIndex(int idx, char* error_message, int message_length);
};

#endif
