//---------------------------------------------------------------------------

#ifndef Ew_AccessControllerH
#define Ew_AccessControllerH
//---------------------------------------------------------------------------
#ifdef __SQLEW__
#include <string>
#include <vector>
#include <map>


// Forward declarations
class TSQLDB;
class TSQLQuery;
class TEngineErrorsPump;

class TEw_AccessController
{
private:
	TSQLDB* FSQLDB;
	TSQLQuery* FAgenciesQry;
	TEngineErrorsPump* FEngineErrorsPump;

	std::vector<std::string> FLoginList;
	std::map<int, std::string> FLoginMap;

	bool is_logged_in(std::string agency_code);
	bool is_uber_user(std::string agency_code, std::string password);
	bool is_valid_login(std::string& agency_code, std::string password, int* agency_pkey);

	int get_logged_in_pkey();

public:
	TEw_AccessController(TEngineErrorsPump* pump, TSQLDB* database);
	~TEw_AccessController();

	int Login(std::string agency_code, std::string password);
	int GetLoginsCount(int* how_many_logins);
	int GetLoginByIndex( const int idx, int* agency_pkey, char* agency_code, const int agency_code_size );
	int GetLoggedInAgencyPKey( const int current_agency_pkey, int* use_this_agency_pkey );

	void MungedPassword(std::string rawpw, char* cookedpw, unsigned int cooked_len);
	bool IsLoggedIn(int agency_pkey);

	// support for Import Metafile
	void AddImportSuperUser(bool& was_super_user);
	void RemoveImportSuperUser(bool was_super_user);
};

#endif // __SQLEW__
#endif
