//---------------------------------------------------------------------------

#ifndef SMFTablesH
#define SMFTablesH

#include <string>

//---------------------------------------------------------------------------
// forward declarations
class TSQLDB;
class TSQLQuery;

enum TSMFTableId { tidControl,  // EE_Control
                   tidAgencies, // EE_Agencies
                   tidEdits,    // EE_Edits
                   tidEditSets, // EE_EditSets
                   tidFields,   // EE_Fields
                   tidLayouts,  // EE_Layouts
                   tidMessages, // EE_Messages
                   tidLookupTables,  // EE_LookupTables
                   // PIVOT TABLES
                   tidEditSetEditsPivot,  // EE_EditSetEditsPivot
                   tidEditErrorsPivot,    // EE_EditErrorsPivot
                   tidEditMessagesPivot,  // EE_EditMessagesPivot
                   tidEditFieldsPivot,    // EE_EditFieldsPivot
                   tidEditTablesPivot,    // EE_EditTablesPivot
                   tidLayoutFieldsPivot   // EE_LayoutFieldsPivot
};

class TSMFTables
{
private:
    TSQLDB* FSQLDB;
    TSQLQuery* FQry;
    std::string FSQL;

	bool create_table_EE_Control(const char* mf_structure_version);
	bool create_table_EE_Agencies();
    bool create_table_EE_Edits();
    bool create_table_EE_EditSets();
    bool create_table_EE_Fields();
    bool create_table_EE_Layouts();
    bool create_table_EE_Messages();
    bool create_table_EE_LookupTables();
    // Pivot tables
    bool create_table_EE_EditSetEditsPivot();
    bool create_table_EE_EditErrorsPivot();
    bool create_table_EE_EditMessagesPivot();
    bool create_table_EE_EditFieldsPivot();
    bool create_table_EE_EditTablesPivot();
    bool create_table_EE_LayoutFieldsPivot();

	bool create_table(TSMFTableId TableId, const char* mf_structure_version = NULL);
	bool create_indexes(TSMFTableId TableId);

	bool toggle_foreign_keys_pragma(bool on_off);
	bool rename_table(const char* orig_name, const char* bak_name);
	bool import_data_from_BAK(const char* mf_structure_version, const char* orig_name, const char* bak_name);
    bool drop_BAK_table(const char* bak_name);
	bool update_mf_structure_version(const char* mf_structure_version);


public:
    TSMFTables(TSQLDB* database);
    ~TSMFTables();

	bool CreateSMFTables(const char* mf_structure_version);
	int UpdateMetafile(const char* mf_structure_version, char* smf_init_error, const int error_buffer_size);

};
#endif
