//---------------------------------------------------------------------------

#ifndef SQLDBH
#define SQLDBH
#include "sqlite3.h"
#include <map>
#include <string>

// Forward declaration, so it can be referenced in TSQLTable and TSQLQuery

typedef int (*CallbackPragma)(void* ptr2Object, int col_count, char** values, char** names);

class TSQLDB
{
private:
	sqlite3 *FDatabase;
	std::string FDBName;

public:
	TSQLDB();
	~TSQLDB();

	bool OpenDatabase(const char* dbname);
	bool CloseDatabase();

	bool Vacuum();

	char * GetLastDBErrorMessage();
	char * GetDBName();

	int Pragma(const char* sql, void* arg_to_callback, void* callback_func);

	// Managing transactions
	bool BeginTrans();
	bool CommitTrans();
	bool RollbackTrans();
	// Nesting transactions
	bool SavePoint(const char* savepoint_name);
	bool Release(const char* savepoint_name);
	bool RollbackTo(const char* savepoint_name);

	sqlite3 *Database();

};


#endif
