//---------------------------------------------------------------------------

#ifndef UtilityH
#define UtilityH
//---------------------------------------------------------------------------
#include <string>


void lowercase( std::string& in_string );
void uppercase( std::string& in_string );

std::string lowercase_string( std::string in_string );
std::string uppercase_string( std::string in_string );

std::string trim(const std::string& str, const std::string& whitespace = " \t");
std::string ltrim(const std::string& str, const std::string& whitespace = " \t");
std::string rtrim(const std::string& str, const std::string& whitespace = " \t");
std::string padright(const std::string inString, unsigned int cnt, char padchar = ' ' ) ;
std::string padleft(const std::string inString, unsigned int cnt, char padchar = ' ' ) ;
std::string intToString( int value ) ;
std::string stringReplace(const std::string instring, const std::string oldpatt, const std::string newpatt);
std::string ci_stringReplace(const std::string instring, const std::string oldpatt, const std::string newpatt, const bool whole_word = false);
size_t ci_stringFind(const std::string instring, const std::string pattern, const bool whole_word = false);
int posix_stricmp(const char *s1, const char *s2);
int get_int_val(const char* s, size_t start_pos, size_t length);
void get_current_date_time(char* s, size_t length);


#ifdef EE_WINDOWS
std::string system_error_message( int error_code );
// #else
// Programmers for Linux compilers will need to provide an OS-appropriate
// alternative to Windows GetLastError() and FormatMessage()
#endif




#endif
