//---------------------------------------------------------------------------

#ifndef VariableH
#define VariableH
//---------------------------------------------------------------------------
#include <string>
#include <vector>
#include <stdint.h> // intptr_t

enum TVariableTypes
{
	VT_ARG,
	EEVT_CHAR,
	EEVT_INT,
	VT_LONG,
	EEVT_ARRAY = 0x40,
	EEVT_PTR = 0x80
};


class TVariable
{
private:
	std::string FVariableName;
	int FVariableType;

	// for String variables
	//std::string FValue;
	intptr_t FStringValue;
	size_t FMaxLength;

	// for Int variables
	std::vector<int> FValues;
public:
	TVariable(const char* var_name, const int var_type, const size_t max_size);
	~TVariable();

	void Reset(const char* var_name, const int var_type, const size_t max_size);

	const char* GetVariableName() { return FVariableName.c_str(); }
	int GetVariableType() { return FVariableType; }

	// for String variables
	size_t GetMaxLength() { return FMaxLength; }

	void SetValue( const char* value );
	void SetTableVarValue( const char* value, size_t length );
	intptr_t GetStringValueAsIntPtr();

	// for Int variables
	void SetValue( const size_t idx, const int value );
	int GetValue(const size_t idx);
	size_t Count();

} ;

#endif
